#!/bin/bash
# Script: e17install - Install e17 cvs with libs
# Author: Steffen Wirth alias bert2002
# Date: 14.02.06
# www.pissflitsche.net/e17
version=0.9.3a


# Please not that e17 has many depends on other programs, if you have problems to build it, look at: http://get-e.org/E17_User_Guide/Legacy/_pages/2.1.html
normal="e17/libs/eet e17/libs/evas e17/libs/ecore e17/libs/embryo e17/libs/edje e17/apps/e e17/libs/ewl"
efl="e17/libs/imlib2 e17/libs/edb e17/libs/eet e17/libs/imlib2_loaders e17/libs/evas e17/libs/ecore e17/libs/epeg e17/libs/embryo e17/libs/edje e17/libs/epsilon e17/libs/esmart e17/libs/etox e17/libs/emotion e17/libs/ewl e17/libs/engrave e17/proto/etk"
modules="e_modules/calendar e_modules/emu e_modules/flame e_modules/monitor e_modules/mount e_modules/rain e_modules/rss e_modules/screenshot e_modules/slideshow e_modules/snow e_modules/tclock e_modules/weather"
full="e17/libs/eet e17/libs/edb e17/libs/evas e17/libs/ecore e17/libs/embryo e17/libs/imlib2 e17/libs/edje e17/apps/e e17/proto/etk e17/libs/epeg e17/libs/epsilon e17/libs/esmart e17/apps/entrance e17/libs/emotion e17/apps/eclair e17/libs/ewl e17/libs/engrave e17/apps/e_utils e17/libs/etox e17/apps/rss "


# User config end here, please dont change next lines, if you dont know what you do :)

function cvsarray {
array=(thinktux.net:/root cvs.sourceforge.net:/cvsroot/enlightenment)
rotation=`expr $RANDOM % 2`
cvsserver=`echo ${array[$rotation]}`
}


function profiler {
			mkdir -p ~/.e17install 2> /dev/null
			if [ -e ~/.e17install/.profile ]; then
				e17profile=`cat ~/.e17install/.profile`
				dialog --title "Profile" --backtitle "e17install $version" --yesno "Do you want use current profile: $e17profile" 5 50
				if [ $? == 0 ]; then
					echo "Profile: Okay"
				else
					rm ~/.e17install/.profile 2> /dev/null
					unset $e17install
					./e17install.sh
					exit 0
				fi
			else
				dialog --title "Profile" --backtitle "e17install $version" --checklist "Please select an Profile" 0 0 0 "normal" "base packages (tip)" "" "full" "all e17 packages" "" "efl" "efl packages" "" "stable" "stable release" "" "modules" "Modules" "" 2> ~/.e17install/.profile
					if [ $? == 0 ]; then
						echo "Okay!"
					else
						rm -rf ~/.e17install/.profile 2>/dev/null
						exit 0
					fi
				e17profile=`cat ~/.e17install/.profile`
			fi
			
			if [ $e17profile == "\"normal\"" ]; then
				eapps=$normal
			else
				if [ $e17profile == "\"full\"" ]; then
					eapps=$full
				else
					if [ $e17profile == "\"efl\"" ]; then
						eapps=$efl
					else
						if [ $e17profile == "\"modules\"" ]; then
							eapps=$modules
							cvsserver=cvs.sourceforge.net:/cvsroot/enlightenment	#modules only at sf.net server
								if [ `id -un` == root ]; then
									dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "You must install the modules as the user you want start enlightenment. Please change the user and restart the script. Not as root the modules :)" 7 54
									rm -rf ~/.e17install/.profile 2>/dev/null
								exit 0
								fi
						else
								if [ $e17profile == "\"stable\"" ]; then
									eapps=estable
								else
									echo "Nothing? I think its an error... help"
								fi
							fi
						fi
					fi 
				fi
}

function depends {
			for idepends in type cvs dialog make gcc; do
				type $idepends >> /dev/null ; if [ $? == 1 ]; then echo "Checking $idepends ... failed... Please install $idepends or check your PATH" && exit 1 ; else echo "Checking $idepends ... Okay" && sleep 0.2; fi
			done
}

function location {
			mkdir -p ~/.e17install/ 2> /dev/null
			if [ -e ~/.e17install/.sourcecode ]; then
				echo "Sourcecode: Okay"
			else
				dialog --title "Sourcecode area" --backtitle "e17install $version" --inputbox "Where is the sourcecode from e17?\nDon\`t end with '/'. You can get errors." 10 50 ~/.e17install 2> ~/.e17install/.sourcecode
			
				if [ $? == 0 ]; then
					echo "Sourcecode: Okay"
				else
					rm -rf ~/.e17install/.sourcecode 2> /dev/null
					echo "Cancel by user or Error: `$?`" && exit 1
				fi
			fi
			e17source=`cat ~/.e17install/.sourcecode`
			mkdir -p $e17source 2> /dev/null
			touch $e17source/test 2> /dev/null
			if [ $? == 1 ]; then
				dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "I have no write permission to: $e17source\n Please restart and correct the path." 6 50
				rm -rf ~/.e17install/.sourcecode 2> /dev/null
				exit 1
			else
				echo "Sourcecode read/write: Okay"
			fi
}


function install {
			if [ -e ~/.e17install/.e17path ]; then
				echo "e17 Install Path: Okay"
			else

				if [ `id -un` == root ]; then
					dialog --title "e17 install area" --backtitle "e17install $version" --inputbox "Where I should install e17?\nDon\`t end with '/'. You can get errors." 10 50 /opt/e17 2> ~/.e17install/.e17path
						if [ $? == 0 ]; then
							echo "e17 Install Path: Okay"
						else
							rm -rf ~/.e17install/.e17path 2> /dev/null
							echo "Cancel by user or Error: `$?`" && exit 1
						fi

				else
					dialog --title "e17 install area" --backtitle "e17install $version" --inputbox "Where I should install e17?\nDon\`t end with '/'. You can get errors." 10 50 ~/e17 2> ~/.e17install/.e17path
				fi
				if [ $? == 0 ]; then
					echo "e17 Install Path: Okay"
				else
					rm -rf ~/.e17install/.e17path 2> /dev/null
					echo "Cancel by user or Error: `$?`" && exit 1
				fi
			fi
			e17path=`cat ~/.e17install/.e17path`
			mkdir -p $e17path 2> /dev/null
			touch $e17path/test 2> /dev/null
			if [ $? == 1 ]; then
				dialog --title "Error" --backtitle "e17install $version" --ok-label "exit" --msgbox "I have no write permission to: $e17source\n Please restart and correct the path." 6 50
				rm -rf ~/.e17install/.e17path 2> /dev/null
				exit 1
			else
				echo "e17 install path read/write: Okay"
			fi
}


function installer {
			export PATH=$PATH:$e17source:$e17path
			export CPPFLAGS="$CPPFLAGS -I$e17path/include"
			export LDFLAGS="$LDFLAGS -L$e17path/lib"
			export WANT_AUTOCONF=2.5
			export WANT_AUTOMAKE=1.7
			dialog --title "Installer" --backtitle "e17install $version" --yesno "Do you want install/update enlightenment DR 17 now?" 5 55
			if [ $? == 0 ]; then
				cd $e17source
				mkdir -p ./e17/log/ 2> /dev/null
				rm -rf ./e17/log/*.log 2> /dev/null
				for iinstaller in $eapps ; do 
					cd $e17source
					cvs -d:pserver:anonymous:@$cvsserver login || echo "Couldnt login to cvs server. Second try" || exit 1 || cvs -d:pserver:anonymous:@$cvsserver login
					cvs -z3 -d:pserver:anonymous:@$cvsserver co $iinstaller || cvs -z3 -d:pserver:anonymous:@$cvsserver co $iinstaller || echo "Error to get the source: $iinstaller" || exit 1
					cd $iinstaller
						./autogen.sh --libdir=$e17path/lib/ --prefix=$e17path && make 2> $e17source/e17/log/`echo $ilib | cut -d / -f3`.log || fehler=1
						if [ $fehler == 1 ] ; then 
							cat  $e17source/e17/log/`echo $ilib | cut -d / -f3`.log
							echo "Error to build $e17source/$iinstaller"
							unset fehler
							exit 1
						fi
					make install && ldconfig
				done
						
				cd $e17source/e17/log/ 2> /dev/null
				for ilog in `ls` ; do
					if [ -s $ilog ]; then
						echo ""
					else
						rm $ilog 2> /dev/null
					fi
				done


			else
				dialog --ok-label "Bye" --title "What a bummer" --backtitle "e17install $version" --msgbox "You miss a great program.\nVisit www.pissflitsche.net/e17" 6 40
				exit 1
			fi
}
###################################################
function e17stable {
	mkdir -p $e17source/stable/log/ && cd $e17source/stable && rm finger_e17 2> /dev/null
	wget http://www.pissflitsche.net/e17/finger_e17
	export PATH=$PATH:$e17path
	export CPPFLAGS="$CPPFLAGS -I$e17path/include"
	export LDFLAGS="$LDFLAGS -L$e17path/lib"
	export WANT_AUTOCONF=2.5
	export WANT_AUTOMAKE=1.7

	for iestable in `cat $e17source/stable/finger_e17` ; do
		if  [ `echo $iestable | cut -b 0-3` == "edb" ]; then
			dialog --title "enlightenment stable" --backtitle "e17install $version" --yesno "The necesssary of e17 stable is compiled (not more recommended). Do you want install more?" 6 50
			if [ $? == 0 ]; then
				echo "Okay, letz rock more fine progs :)"
			else
				final
				exit 0
			fi
		fi
		if [ -e $iestable.tar.gz ]; then
			echo "File exist: Okay"
		else
			cd $e17source/stable
			wget http://enlightenment.freedesktop.org/files/$iestable.tar.gz || wget -c http://enlightenment.freedesktop.org/files/$iestable.tar.gz
		fi

		tar -xzf $iestable.tar.gz && cd $iestable
		./configure --libdir=$e17path/lib/ --prefix=$e17path && make 2> $e17source/stable/log/`echo $iestable | cut -d 0-3`.log || fehler=1
				if [ $fehler == 1 ] ; then 
					cat  $e17source/stable/log/`echo $iestable | cut -d 0-3`.log
					echo "Error to build $e17source/stable/$iinstaller"
					unset fehler
					exit 1
				fi
		make install && ldconfig
	done
}






function final {
			if [ -x $e17path/bin/enlightenment ] ; then
				echo "startx $e17path/bin/enlightenment -- -nolisten tcp" > $e17path/bin/e17 && chmod a+x $e17path/bin/e17 2> /dev/null
			else
				dialog --title "Compile Error" --backtitle "e17install $version" --msgbox "Cannot locate enlightenment. Is everything compiled correctly?\nPlease look in $e17source/e17/log/ to find the error" 6 70
				exit 1
			fi
			clear
			dialog  --title "complete" --backtitle "e17install $version" --msgbox "We have installed follow apps: $eapps" 8 80
			dialog --title "Ready to start" --backtitle "e17install $version" --msgbox "An Error Log you can find in: $e17source/e17/log/\nYou can Start enlightenment with '$e17path/e17' in one tty. Please close X before you start e17." 7 75

}

function genmenu {
			dialog --title "e17genmenu" --backtitle "e17install $version" --yesno "Do you want install e17genmenu to generate menues?" 7 40 
			if [ $? == 0 ]; then
				cvsserver=cvs.sourceforge.net:/cvsroot/enlightenment
				iinstaller=e17/apps/e_utils
				mkdir -p $e17source/genmenu && cd $e17source/genmenu
				cvs -d:pserver:anonymous:@$cvsserver login || echo "Couldnt login to cvs server. Second try" || exit 1 || cvs -d:pserver:anonymous:@$cvsserver login
				cvs -z3 -d:pserver:anonymous:@$cvsserver co $iinstaller || cvs -z3 -d:pserver:anonymous:@$cvsserver co $iinstaller || echo "Error to get the source: $iinstaller" || exit 1
				cd $iinstaller
				./autogen.sh --libdir=$e17path/lib/ --prefix=$e17path && make || fehler=1
					if [ $fehler == 1 ] ; then 
							echo "Error to build $e17source/$iinstaller"
							unset fehler
							exit 1
					fi
				make install && ldconfig
				if [ `id -un` == root ]; then
					echo "For which user you want to create the menu (or root)?
					echo "User: `ls /home/`
					echo -n "User:"
					read e17user
					su - $e17user -c "e17genmenu"
				else
					echo -n "Do you want run e17genmenu? [y/n]"
					read eyn
					if [ $eyn == y ]; then
						e17genmenu
						echo "If you want run generate later new menus, you must only run: 'e17genmenu'"
					else
						echo "Who does not want that has already :)"
					fi
				fi
			else
				exit 0
			fi
					
				
}


# Now we start all functions in a fine order :)
if [ $1 == --help ] 2>/dev/null ; then
	clear
	echo "e17install $version"
	echo "Usage: ./e17install.sh [OPTION...]"
	echo "  --help		this help screen"
	echo "  --genmenu		to generate menues after install "
	echo "			(http://sourceforge.net/projects/e17genmenu)"
	echo ""
	exit 0
fi
# to check some depends
depends
if [ $1 == --genmenu ]; then
	genmenu
	exit 0
fi
#cvs server rotation
cvsarray
#set and check the profiler
profiler
# setup or check the source location
location
if [ $e17profile == "\"stable\""  ]; then
	install
	e17stable
	final
	exit 0
fi
# to set the install folder
install
# lets check out the cvs and build e17
installer
# the last fine test to check e17 install
final

# EOF
